#include "Globals.h"
#include <math.h>
#include <stdio.h> 
 double xconversione(Display *display, Manager man, double *x, int ndata, int xpixel, double xdato, int tipo_conversione)
 {
  double xfac; 
  xfac = (man.width-2*FRAME)/fabs(x[ndata-1]-x[0]);
  if(tipo_conversione == -1)
  {
    xdato = (xpixel - FRAME)*(1/xfac) + x[0];
    return xdato;
  }  
  if(tipo_conversione == 1)
  {
    xpixel = (xdato - x[0])*xfac + FRAME;
    return xpixel;
  }
 }
 
 double yconversione(Display *display, Manager man, double *y, int ndata, int ypixel, double ydato, int tipo_conversione)
 {
  double yfac;
  double ymax = y[0];
  double ymin = y[0];
  int i;
  for (i=1; i<ndata; i++)
  {
    if(ymax<y[i]) ymax=y[i];      
    if(ymin>y[i]) ymin=y[i]; 
  }
  
  int h = (man.height-2*FRAME)*(1+YSCALE)/2;
  yfac = (man.height-2*FRAME)/(ymax-ymin)*YSCALE;
  
  if(tipo_conversione == -1)
  {
    ydato = (h - ypixel + FRAME)*(1/yfac) + ymin;
    return ydato;
  }  
  if(tipo_conversione == 1)
  {
    ypixel = h - (ydato - ymin)*yfac + FRAME;
    return ypixel;
  }
 }
 
 int xdiretta(Display *display, Manager man, double *x, int ndata, double xdato)
 {
   int xpixel;
   return xpixel = (int)xconversione(display, man, x, ndata, 0, xdato, 1);
 }
 
 double xinversa(Display *display, Manager man, double *x, int ndata, int xpixel)
 {
   double xdato;
   return xdato = xconversione(display, man, x, ndata, xpixel, 0, -1);
 }
 
 
 int ydiretta(Display *display, Manager man, double *y, int ndata, double ydato)
 {
   int ypixel;
   return ypixel = (int)yconversione(display, man, y, ndata, 0, ydato, 1);
 }
 
 double yinversa(Display *display, Manager man, double *y, int ndata, int ypixel)
 {
   double ydato;
    ydato = yconversione(display, man, y, ndata, ypixel, 0, -1);
    return ydato;
 }
 
 
   
